Lavalite package that provides c_m management facility for the cms.

## Installation

Run the below command form the root folder of lavalite.

```
    composer require "adunate/c_m"
```


## Migration and seeds

```
    php artisan migrate
    php artisan db:seed --class=Adunate\\CM\\Seeders\\CMTableSeeder
```

## Publishing

* Configuration
```
    php artisan vendor:publish --provider="Adunate\CM\Providers\CMServiceProvider" --tag="config"
```
* Language
```
    php artisan vendor:publish --provider="Adunate\CM\Providers\CMServiceProvider" --tag="lang"
```
* Views
```
    php artisan vendor:publish --provider="Adunate\CM\Providers\CMServiceProvider" --tag="view"
```


## URLs and APIs


### Web Urls

* Admin
```
    http://path-to-route-folder/admin/c_m/{modulename}
```

* User
```
    http://path-to-route-folder/user/c_m/{modulename}
```

* Public
```
    http://path-to-route-folder/c_m_s_s
```


### API endpoints

These endpoints can be used with or without `/api/`
And also the user can be varied depend on the type of users, eg user, client, admin etc.

#### Resource

* List
```
    http://path-to-route-folder/api/user/c_m/{modulename}
    METHOD: GET
```

* Create
```
    http://path-to-route-folder/api/user/c_m/{modulename}
    METHOD: POST
```

* Edit
```
    http://path-to-route-folder/api/user/c_m/{modulename}/{id}
    METHOD: PUT
```

* Delete
```
    http://path-to-route-folder/api/user/c_m/{modulename}/{id}
    METHOD: DELETE
```

#### Public

* List
```
    http://path-to-route-folder/api/c_m/{modulename}
    METHOD: GET
```

* Single Item
```
    http://path-to-route-folder/api/c_m/{modulename}/{slug}
    METHOD: GET
```

#### Others

* Report
```
    http://path-to-route-folder/api/user/c_m/{modulename}/report/{report}
    METHOD: GET
```

* Export/Import
```
    http://path-to-route-folder/api/user/c_m/{modulename}/exim/{exim}
    METHOD: POST
```

* Action
```
    http://path-to-route-folder/api/user/c_m/{modulename}/action/{id}/{action}
    METHOD: PATCH
```

* Actions
```
    http://path-to-route-folder/api/user/c_m/{modulename}/actions/{action}
    METHOD: PATCH
```

* Workflow
```
    http://path-to-route-folder/api/user/c_m/{modulename}/workflow/{id}/{transition}
    METHOD: PATCH
```
